// -----------------------------------------------------
// Datei: palindrom.cpp 
// Zweck: Textzeilen einlesen und vergleichen.
// -----------------------------------------------------

#include <iostream>
#include <string>
using namespace std;

string header = " * * * Palindrom-Test * * * ",
       prompt = "Geben Sie ein Wort ein: ",
       linie( 50, '-');

int main()
{
   string wort;                      // Leerer String
   char taste = 'j';

   cout << "\n\t" << header << endl;
   while( taste == 'j' || taste == 'J') 
   {
      cout << '\n' << linie  << '\n'
           << prompt;

      cin >> wort;

      // Erstes und letzte Zeichen vergleichen,
      // zweites und vorletztes usw.
      int i = 0, j = wort.length() - 1;
      for( ; i <= j ; ++i, --j)   
        if( wort[i] != wort[j] ) 
            break;
      
      if( i > j)                     // Alle Zeichen gleich?
         cout << "\nDas Wort " << wort 
              << " ist ein P A L I N D R O M !" << endl;
      else
         cout << "\nDas Wort " << wort
              << " ist kein Palindrom" << endl;

      cout << "\nWiederholen? (j/n) ";
      do
        cin.get(taste);
      while(    taste != 'j' && taste != 'J'
             && taste != 'n' && taste != 'N');
   }
   return 0;
}
