// konto.h 
// Definition der Klasse Konto.
// ---------------------------------------------------

#ifndef KONTO_H   // Mehrfaches inkludieren verhindern.
#define KONTO_H

#include <iostream>
#include <string>
using namespace std;

class Konto
{
  private:              // Geschtzte Elemente:
    string name;            // Kontoinhaber
    unsigned long nr;       // Kontonummer
    double stand;           // Kontostand

  public:               // ffentliche Schnittstelle:
    bool init( const string&, unsigned long, double);
    void display();
};

#endif   //  KONTO_H
