// konto.h 
// Definition der Klasse Konto mit zwei Konstruktoren.
// ---------------------------------------------------
#ifndef KONTO_H
#define KONTO_H

#include <string>
using namespace std;

class Konto
{
   private:              // Geschtzte Elemente:
     string name;            // Kontoinhaber
     unsigned long nr;       // Kontonummer
     double stand;           // Kontostand

   public:               // ffentliche Schnittstelle:
     Konto( const string&, unsigned long, double );
     Konto( const string& );
     bool init( const string&, unsigned long, double);
     void display();
};

#endif   //  KONTO_H
