// Euro_io.cpp
// Die Shift-Operatoren fr die Ein- und Ausgabe von
// Euro-Objekten berladen.
// ---------------------------------------------------
#include "Euro.h"
#include <iostream>
using namespace std;

// Auf Stream os ausgeben.
ostream& operator<<(ostream& os, const Euro& e)
{
    os << e.asString() << " Euro";
    return os;
}

// Von Stream is einlesen.
istream& operator>>(istream& is, Euro& e)
{
    cout << "Euro-Betrag (Format ...x,xx): ";

    int euro = 0, cents = 0;
    char c = 0;
    if( !(is >> euro >> c >> cents))
      return is;
    if( (c != ',' && c != '.') || cents >= 100)   // Fehler?
      is.setstate( ios::failbit);      // Ja => fail-Bit setzen.
    else
      e = Euro( euro, cents);

    return is;
}

