// ------------------------------------------------------
// produc_t.cpp
// Test von Up- und Down-Casts fr die Klassen
// Product, PackedFood und UnpackedFood.
// ------------------------------------------------------
#include "product.h"

const Product& isLowerCode(const Product& p1,
                           const Product& p2);

int main()
{
   Product* pv[3] = { NULL };
   UnpackedFood* pu = NULL;

   pv[0] = new Product(12345L, "Mehl");
   pv[1] = new PackedFood(23456, "Salz", 0.49);
   pv[2] = new UnpackedFood(98765, "Trauben", 1.5, 1.69);

   pu =  new UnpackedFood(56789, "Pfirsische", 2.5, 2.69);

   cout << "\nEine unverpackte Ware: ";
   pu->printer();

   cout << "\nDie Basis-Info der anderen Produkte:";
   for(int i=0; i < 3; ++i)
       pv[i]->printer();

   cout << "\nWeiter mit <Return> ";  cin.get();

   cout << "\nUnd nun mit Down-Cast: " << endl;
   static_cast<PackedFood*>(pv[1])->printer();
   static_cast<UnpackedFood*>(pv[2])->printer();

   cout << "\nUnd ein Up-Cast: " << endl;
   static_cast<Product*>(pu)->printer();

   cout << "\nWeiter mit <Return> ";  cin.get();

   cout << "\nJetzt werden Bar-Codes verglichen!" << endl;

   cout << "\nKleinerer Bar-Code bei Mehl oder Salz?";
   isLowerCode(*pv[0], *pv[1]).printer();

   cout << "\nKleinerer Bar-Code bei Salz oder Trauben?";
   isLowerCode(*pv[1], *pv[2]).printer();

   return 0;
}

const Product& isLowerCode(const Product& p1, const Product& p2)
{
    if(p1.getCode() < p2.getCode())
        return p1;
    else 
        return p2;
}

