// ---------------------------------------------------
// kontsort.cpp: Sortiert einen Vektor von Zeigern
//               auf Konten nach Kontonummern.
// ---------------------------------------------------

#include "konto.h"

void ptrSwap(Konto**, Konto** );

void kontoSort( Konto** kptr, int n)
{
   Konto **temp, **minp, **lastp;
   lastp = kptr + n - 1;    // Zeiger auf letzten Zeiger
                            // im Vektor.

   for(  ; kptr < lastp; ++kptr )
   {
     minp = kptr;

     for( temp = kptr + 1; temp <= lastp; ++temp )
     { 
       if( (*temp)->getNr() < (*minp)->getNr() )
           minp = temp; 
     }
     ptrSwap( kptr, minp );
   }
}

void ptrSwap( Konto **p1, Konto **p2 )
{
   Konto *help;
   help = *p1; *p1 = *p2; *p2 = help;
}

int main()
{
    Konto* koptrArr[3];

    string name;
    long nr;
    double wert;
    int i;

    cout << "\n3 Konten einlesen: " << endl;
    for( i = 0; i < 3; i++)
    {
        cout << "\nName?        "; cin >> name;
        cout <<   "Kontonummer? "; cin >> nr;
        cout <<   "Betrag?      "; cin >> wert;
        cin.clear();  cin.ignore(LLONG_MAX,'\n');

        koptrArr[i] = new Konto(name, nr, wert);
    }

    cout << "\n\n\nDer Vektor: " << endl;
    for(i=0; i < 3; i++)
        koptrArr[i]->display();
    cout << endl;  cin.get();

    kontoSort(koptrArr, 3);

    cout << "\n\nDer sortierte Vektor: " << endl;
    for(i=0; i < 3; i++)
        koptrArr[i]->display();
    cout << endl; cin.get();

    return 0;
}
