// -----------------------------------------------------
// Passw1.cpp
// Definition der Funktionen getPassword() und zeitdiff()
// zum Einlesen und berprfen eines Passwortes.
// -----------------------------------------------------
#include <iostream>
#include <iomanip>
#include <string>
#include <ctime>
using namespace std;

long zeitdiff(void);                      // Prototyp
static string geheimwort = "ISUS";        // Passwort 
static long  maxanzahl = 3, maxzeit = 60; // Limits

bool getPassword()  // Passwort einlesen und berprfen.
{                 // Return-Wert: true, falls Passwort ok.
   bool ok_flag = false;        // Fr die Rckgabe 
   string wort;                 // Fr die Eingabe 
   int anzahl = 0, zeit = 0;

   zeitdiff();                   // Die Stoppuhr starten
   while( ok_flag != true && 
          ++anzahl <= maxanzahl) // Anzahl Versuche 
   {
      cout << "\n\nGeben Sie das Passwort ein:  ";
      cin >> setw(20) >> wort;
      cin.ignore(LLONG_MAX,'\n');  // Rest der Zeile lschen

      zeit += zeitdiff();
      if( zeit >= maxzeit )        // Im Zeitlimit?
         break;                    // nein!
      if( wort != geheimwort)
         cout << "Passwort ungueltig!" << endl;
      else 
         ok_flag = true;           // Erlaubnis geben
    }
    return ok_flag;                // Ergebnis
}

long zeitdiff()                 // Liefert die Anzahl Sekunden
{                               // seit dem letzten Aufruf.
    static time_t  sek = 0;       // Zeit vom letzten Aufruf.
    time_t  altsek = sek;         // Alte Zeit merken.
    time( &sek);                  // Neue Zeit lesen.
    return long(sek - altsek);    // Differenz zurckgeben.
}


int main()
{
    if( getPassword())
        cout << "Passwort richtig!" << endl;
    else
        cout << "War nichts!" << endl;

    return 0;
}
