// structs.cpp 
// Eine Struktur definieren und verwenden.
// ---------------------------------------------------
#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

struct Vertreter   // Definition der Struktur Vertreter
{
  string name;         // Name des Vertreters.
  double umsatz;       // Sein Umsatz pro Monat.
};

inline void print( const Vertreter& v)
{
   cout << fixed << setprecision(2)
        << left  << setw(20) << v.name
        << right << setw(10) << v.umsatz << endl;
}
 
int main()
{
   Vertreter heidi, hannes; 

   heidi.name    = "Sturm, Heidi"; 
   heidi.umsatz  = 37000.37;

   hannes.name   = "Forsch, Hannes";
   hannes.umsatz = 23001.23;

   heidi.umsatz += 1700.11;

   cout << "  Vertreter            Umsatz\n" 
        << "-------------------------------" << endl;
   print( heidi);
   print( hannes);
   cout << "\nSumme der Umsaetze: "
        << heidi.umsatz + hannes.umsatz << endl; 

   Vertreter *ptr = &hannes;         // Zeiger ptr.
                                     // Wer macht die 
   if( hannes.umsatz < heidi.umsatz) // meisten Umstze?
     ptr = &heidi;

   cout << "\nUnser bestes Pferd im Stall: "
        << ptr->name << endl;    // Name des Vertreters,
                                 // auf den ptr zeigt. 
   return 0;
}
