// tuple_demo.cpp: Das Template tuple verenden.
//------------------------------------------------
#include <tuple>
#include <iostream>
#include <string>
using namespace std;

tuple<long, string, double> einArtikel()
{
    return make_tuple(333L, string("TV"), 499.49);
    // return { 100L, "TV", 499.49 };      // Auch mglich.
}

int main()
{
    tuple<long, string, double> art0(100L, "Radio", 199.19);
    // Typableitng aus den Konstruktor-Argumenten:
    tuple art1(200L, string("Notebook"), 666.66); 

    auto art2 = einArtikel();

    get<2>(art0) -= 50.0;                  // Preis von art0 reduzieren.
    cout << "\nNummer: " << get<0>(art0) << '\n'
         <<   "Name:   " << get<1>(art0) << '\n'
         <<   "Preis:  " << get<2>(art0) << endl;

    long nr1;  string name1;  double preis1;
    tie(nr1, name1, preis1) = art1;
    cout << "\nNummer: " << nr1 << '\n'
         <<   "Name:   " << name1 << '\n'
         <<   "Preis:  " << preis1 << endl;

    auto[nr2, name2, preis2] = art2;      // Structured Bindings
    cout << "\nNummer: " << nr2 << '\n'
         <<   "Name:   " << name2 << '\n'
         <<   "Preis:  " << preis2 << endl;

    return 0;
}
