// -----------------------------------------------------
// artike_t.cpp 
// Die Klasse Artikel mit Kopierkonstruktor testen.
// -----------------------------------------------------

#include "artikel.h"           // Definition der Klasse
#include <iostream>
#include <string>
using namespace std;

void test( Artikel a);                     // Prototyp

Artikel artikel1( 1111,"Zelt", 159.9);     // global

int main()
{
   cout << "\nDie erste Anweisung in main().\n" << endl;
  
   Artikel artikel2( 2222,"Jogging-Schuhe", 199.99);

   cout << "\nDer erste Aufruf von test()." << endl;
   test(artikel1);                       // Call by Value

   cout << "\nDer zweite Aufruf von test()." << endl;
   test(artikel2);                       // Call by Value

   cout << "\nDie letzte Anweisung in main().\n"
        << "\nEs gibt noch " << Artikel::getAnzahl()
        << " Objekte\n" << endl;

   return 0; 
}

void test( Artikel a)    // Aufruf des Kopierkonstruktors
{
   cout << "\nDas uebergebene Objekt:" << endl;
   a.print();
   
   static Artikel rad( 3333, "Fahrrad", 999.0);
   cout << "\nDas statische Objekt der Funktion test():"
        << endl; 
   rad.print();
     
   cout << "\nDie letzte Anweisung in der Funktion test()"
        << endl;
}
