// ------------------------------------------------------
// Pizza_r.cpp
// Demo fr blockweises Lesen von Datenstzen.
// Liest Daten, die mit Pizza_w.cpp geschrieben wurden.
// ------------------------------------------------------
#include "Pizza.h"

char pizzaDatei[256] = DATEINAME;

int main()         // Datenstze lesen und anzeigen.
{
   header();

   ifstream inFile( pizzaDatei, ios::in | ios::binary);
   if( !inFile)
   {
      cerr << "Pizza-Datei nicht vorhanden!" << endl;
      return 1;
   }
   Pizza einePizza;
   int anz = 0;

   cout << "\n-----------------------------------------------"
        << "\nDie Pizzen im Angebot:\n" << endl;
   cout << fixed << setprecision(2);
   while( true)
      if( !inFile.read( (char*)&einePizza, sizeof(Pizza)) )
          break;
      else
      {
          cout << setw(20) << einePizza.name
               << setw(10) << einePizza.preis << endl;
          ++anz;
      }

   cout << "\n-----------------------------------------------\n"
        << endl;

   if( !inFile.eof())
   {
      cerr << "Fehler beim Lesen der Datei!" << endl;
      return 2;
   }
   else
      cerr << "Das sind " << anz << " Pizzen!\n" << endl;

   return 0;
}
