// ------------------------------------------------------
// Pizza_w.cpp
// Demo fr blockweises Schreiben von Datenstzen.
// Schreibt Daten, die mit Pizza_r.cpp gelesen werden.
// ------------------------------------------------------
#include "Pizza.h"

Pizza pizzaKarte[MAXANZ] =
{
   { "Margerita", 9.90F },    { "Regina", 15.90F },
   { "Pizza Fungi", 12.50F }, { "Calzone", 14.90F } };

int anz = 4;
char pizzaDatei[256] = DATEINAME;

int main()         // Datenstze schreiben.
{
   int i;
   header();

   cout << "\nUnser Standard-Angebot:\n" << endl;
   cout << fixed << setprecision(2);
   for( i = 0; i < anz; ++i)
      cout << setw(20) << pizzaKarte[i].name
           << setw(10) << pizzaKarte[i].preis << endl;

   cout << "\n-----------------------------------------------\n"
        << endl;

   // Weitere Datenstze von der Tastatur einlesen:
   while( anz < MAXANZ)
   {
     cout << "Welche Pizza soll noch auf die Karte?\n\n"
          << "Name:  ";
     cin.getline( pizzaKarte[anz].name, 32);
     if( pizzaKarte[anz].name[0] == '\0')
       break;

     cout << "Preis: ";
     cin >> pizzaKarte[anz].preis;

     if( !cin)
        cerr << "Ungueltige Eingabe!" << endl;
     else
        ++anz;

     cin.clear();                    // Fehlerflags lschen.
     cin.ignore( LLONG_MAX, '\n');   // Eingabepuffer leeren.

     if( anz < MAXANZ)
        cout << "\n... und die nchste Pizza!\n"
             << "Zur Beendigung nur <Return> eingeben.\n";
   }

   // Daten in die Datei schreiben:
   int exitCode = 0;
   ofstream outFile( pizzaDatei, ios::out | ios::binary);
   if( !outFile)
   {
      cerr << "Fehler beim Oeffnen der Datei!" << endl;
      exitCode = 1;
   }
   else
   {
      for( int i = 0; i < anz; ++i)
        if( !outFile.write( (char*)&pizzaKarte[i], sizeof(Pizza)) )
        {
           cerr << "Fehler beim Schreiben der Datei!" << endl;
           exitCode = 2;
        }
   }
   if( exitCode == 0)
     cout << "\nDaten in die Datei " << pizzaDatei
          << " geschrieben\n" << endl;

   return exitCode;
}

