// ----------------------------------------------------
// stackn_t.cpp: Testen des Stack-Templates Stack<T, n>
// ----------------------------------------------------
#include <iostream>
#include <iomanip>
using namespace std;

#include "stackn.h"

typedef Stack<unsigned, 256> USTACK; 

void fill(  USTACK& stk );
void clear( USTACK& stk );

int main()
{
    USTACK ustk;            // Original 
    fill( ustk);            // fllen.

    USTACK ostk(ustk);      // Kopieren,
    cout << "\nKopie: " << endl;
    clear( ostk);           // Kopie ausgeben u. leeren.

    cout << "\nOriginal: " << endl;
    clear( ustk );          // Original ausgeben und leeren.

    return 0;
}

void fill( USTACK& stk ) 
{
    unsigned x;
    cout << "Positive ganze Zahlen eingeben "
         << "(Abbruch mit 0): \n";

    while( cin >> x  && x != 0 )
      if( !stk.push(x) )
      { 
          cerr << "Stack voll!";
          break;
      }
}

void clear( USTACK& stk ) 
{
    if(stk.empty()) 
        cerr << "Stack leer!" << endl;
    else
    {  
       unsigned x;
       
       while( stk.pop(x))
         cout << setw(8) << x << "  ";
       cout << endl;
    }
}
