//  toupper.cpp fr Windows
//  Filter zur Umwandlung in Grossbuchstaben
//  Umlaute und das scharfe s () werden im erweiterten ASCII-Zeichensatz
//  (= OEM-Zeichensatz, CP850) dargestellt, da dies in einer
//  Konsolenanwendung der Zeichensatz zur Ausfuehrungszeit ist.
//  Die Eingabe von der Tastatur mit
//  Strg+Z (DOS/Windows) beenden.
// ------------------------------------------------------------

#include <iostream>
#include <cctype>
using namespace std;

int main()
{
   char c;
   while ( cin.get(c) )       // solange ein Zeichen
   {                          // gelesen werden kann.
      switch( c )
      {                                 // deutsche Umlaute
         case ''   :  c = '';         // Zeichen 
//       case '\x84':  c = '\x8E';
                       break;

         case ''   :  c = '';         // Zeichen 
//       case '\x94':  c = '\x99';
                       break;

         case ''   :  c = '';         // Zeichen 
//       case '\x81':  c = '\x9A';
                       break;

         case ''   :                   // Zeichen 
//       case '\xE1':
                       cout.put('S'); c = 'S';
                       break;

         default:   c = toupper(c);    // andere Zeichen
       }
       cout.put(c);     // umgewandeltes Zeichen ausgeben
   }
   return 0;
}
