// -----------------------------------------------------
// Datei: str_Jahr.cpp
// Zweck: Einfgen, Suchen und Ersetzen in Strings.
// -----------------------------------------------------

#include <iostream>
#include <string>
using namespace std;

string header = "Demo zum Arbeiten mit Strings\n",
       s1 = "Alle Jahre kommt ...",
       s2 = "wieder ";

int main()
{
   size_t pos = 0;

   cout << header << endl;
   cout << "s1 : " << s1 << endl;

   // Einfgen:
   cout << "\nString \"" << s2 << "\" einfuegen:" << endl;

   pos = s1.find("kommt");
   if( pos != string::npos )
      s1.insert(pos,s2);

   cout << "s1 : " << s1 << endl;          // Ergebnis

   // Lschen:
   cout << "\nRest ab String \"kommt\" loeschen:" << endl;

   pos = s1.find("kommt");
   if( pos != string::npos )
      s1.erase(pos);

   cout << "s1 : " << s1 << endl;          // Ergebnis

   // Ersetzen:
   cout << "\n\"Jahre\" durch \"kommen\" ersetzen:" << endl;

   pos = s1.find("Jahre");
   if( pos != string::npos )
      s1.replace(pos, 5, "kommen");

   cout << "s1 : " << s1 << endl;          // Ergebnis

   return 0;
}

