// ---------------------------------------------------------
// vek_t.cpp : Ausnahmebehandlung fr float-Vektoren testen.
// ---------------------------------------------------------
#include <iostream>
#include <iomanip>
using namespace std;

#include "FloatVek.h"

int main()
{
    const FloatVek v(10, 9.9f); 
    bool ok = false;

    while( !ok)
    {
      try
      {
        cout << "Hier der konstante Vektor v: \n";
        
        cout << setw(8) << v <<endl;

        int i;
        cout << "Index? "; cin >> i;
        cout << "\nGelesener Wert: " <<  v[i] << endl;
        ok = true;
      }
      catch(BadIndex& err)
      {
        cerr << "Fehler beim Leszugriff.\n"
             << "\nUnzulaessiger Index: " 
             << err.getBadIndex() << endl;
      }
    }

    FloatVek w(20);           // Vektor w,  
    cout << "\nIm neuen Vektor w Zahlen einfuegen: \n";
    try
    {
        w.insert(1.1F, 0);    // Schreibzugriffe.
        w.insert(2.2F, 1);

//      w.insert(3.3F, 3);    // Fehler! Nur Positionen 0,1,2 mglich 

        w[10] = 5.0;          // Fehler!

//      w.remove(7);          // Fehler! Position 7 nicht belegt.
    }
    catch(BadIndex& err)
    {
        cerr << "\nFehler beim Schreibzugriff! "
             << "\nUnzulaessiger Index: " 
             << err.getBadIndex() << endl;
    }

    cout << "\nHier der Vektor w: \n";
    cout << setw(5) << w << endl;

    return 0;
}
