// ----------------------------------------------------
// datum_t.cpp 
// Mit Objekten der Klasse Datum arbeiten.
// ----------------------------------------------------

#include "datum.h" 

#include <iostream>
using namespace std;

int main()
{
   Datum today, birthday, aDate;

   today.init();
   birthday.init( 6, 10, 2016);

   cout << "Das heutige Datum : ";
   today.print();
   
   cout << "\nDer Geburtstag von Felix: ";
   birthday.print();

   cout << "----------------------------------\n"
           "Noch einige Testausgaben:" << endl;

   aDate = today;                 // Zuweisung ok
   aDate.print();

   Datum *pDate = &birthday;      // Zeiger auf birthday
   pDate->print();
  
   Datum &holiday = aDate;        // Referenz auf aDate.
   
   holiday.init( 1,5,2022);       // aDate berschreiben.
   aDate.print();                 // holiday.print();

   return 0;
}

