// reverse.cpp 
// Definition und Aufruf der Funktion reserve().
// reserve() kopiert einen C-String und in einen zweiten
// dreht dabei die Reihenfolge der Zeichen um. 
// -----------------------------------------------------

#include <iostream>
using namespace std;
#include <string.h>      // Header-Datei fr C-Strings,
                         // hier fr strlen().
void reverse(char str[], char umstr[]);    // Prototyp

int main()               // Ein Wort einlesen und 
{                        // "verdreht" wieder ausgeben.
   const int ANZ = 81;
   char wort[ANZ], umwort[ANZ];

   cout << "Geben Sie ein Wort ein: ";
   cin.width(ANZ);       // maximal ANZ-1 Zeichen lesen
   cin >> wort;

   reverse(wort, umwort);

   cout << "\nDas \"verdrehte\" Wort:   " << umwort
        << endl ;

   return 0;
}

void reverse(char s1[], char s2[])       // Kopiert den
{                         // C-String s1 verdreht in s2
   int j = 0;

   for( int i = strlen(s1)-1; i >= 0; i--, j++)
      s2[j] = s1[i];

   s2[j] = '\0';                    // Stringendezeichen
}
