// -------------------------------------------------------
// Fract_t.cpp (Kapitel 19)
// Die Klasse Fraction mit Typkonvertierungen testen.
// Module: Fract_t.cpp  Fraction.cpp
// -------------------------------------------------------
#include "Fraction.h"
#include <iostream>
using namespace std;

int main()
{
   Fraction a, b(-1,5), c(2.25);
   double x = 0.5, y;

   a = x;                     // double -> Fraction 

   cout << "\nEinige Testausgaben:\n" << endl;
   cout << " a = " << a << endl;
   cout << " b = " << b << endl;
   cout << " c = " << c << endl;

   cout << "\nDie Brueche als double-Werte:\n" << endl;
                              // Fraction -> double
   cout << " a = " << (double)a << endl;
   cout << " b = " << (double)b << endl;
   cout << " c = " << (double)c << endl;

   cout << "\nUnd damit rechnen:\n" << endl;
   cout << " a + b = " << (a + b) << endl;
   cout << " a - b = " << (a - b) << endl;
   cout << " a * b = " << (a * b) << endl;
   cout << " a / b = " << (a / b) << endl;

   cout << "  --a =  " <<  --a << endl;
   cout << "  ++a  = " <<  ++a << endl;

   cout << "\nUnd jetzt eine Eingabe\n";
   cin  >> a;
   cout << "\nIhre Eingabe:    " << a << endl;
   a.kuerzen();
   cout << "\nGekuerzt:        " << a << endl;
   cout << "\nAls double-Wert: " << (double)a << endl;

   cout << "\nEine Gleitpunktzahl eingeben: ";
   cin >> x;
   cout << "\nDas ist als Bruch:            " << (Fraction)x
        << endl;

// Summe b + x berechnen:

   cout << " b = " << b << endl;
   cout << " x = " << x << endl;

// a = b + x;                 // Fehler: mehrdeutig!
   a = b + Fraction(x);       // ok! Mit Brchen rechnen. 
   y = (double)b + x;         // ok! Mit double rechnen.

   cout << " b + x  als Bruch:   " << a << endl;
   cout << " b + x  als double:  " << y << endl;

   a = b + Fraction(5);       // int -> Fraction.
   long n = (long)a;          // Fraction -> double -> long.
   cout << " b + 5 als long:  " << n << endl;

   return 0;
}
