// DynObj.cpp 
// Die Operatoren new und delete fr Klassen.
// ---------------------------------------------------

#include "Konto.h"
#include <iostream>
using namespace std;

Konto *clone( const Konto* pK); // Kopie dynamisch erzeugen.

int main()
{
   cout << "Dynamisch erzeugte Objekte.\n" << endl;

   // Speicher reservieren:
   Konto *ptrK1, *ptrK2, *ptrK3;
 
   ptrK1 = new Konto;           // Mit Default-Konstruktor.
   ptrK1->display();            // Default-Werte anzeigen. 

   ptrK1->setNr(302010);                // Andere Werte mit
   ptrK1->setName("Meier, Max");        // Zugriffsmethoden
   ptrK1->setStand(2345.87);            // setzen.
   ptrK1->display();            // Neue Werte anzeigen. 
 
   // Konstruktor mit drei Argumenten verwenden:
   ptrK2 = new Konto( "Lieblich, Anna", 7531357, 999.99);
 
   ptrK2->display();            // Neues Konto anzeigen.
 
   ptrK3 = clone( ptrK1);       // Zeiger auf dynamisch 
                                // erzeugte Kopie.
   cout << "Kopie vom ersten Konto: " << endl;
   ptrK3->display();            // Kopie anzeigen.

   delete ptrK1;                // Speicher freigeben
   delete ptrK2;
   delete ptrK3;

  return 0;
}

Konto *clone( const Konto* pK)  // Kopie dynamisch erzeugen.
{
    return new Konto( *pK);
}
