// -------------------------------------------------------
//  liste_t.cpp
//  Die Klasse Liste mit Kopierkonstruktor und
//  Zuweisung testen.
// -------------------------------------------------------

#include "liste.h"

int main()
{
   cout << "\n * * *  Die Klasse Liste testen  * * *\n"
        << endl;

   Liste  liste1;                // Eine Liste

   cout << liste1 << endl;       // Liste noch leer.

   Datum datum( 11,8,1999);
   double betrag( +1234.56);
   liste1.pushBack( datum, betrag);

   datum.setDatum( 29, 2, 2000);
   betrag = -1000.99;
   liste1.pushBack( datum, betrag);

   datum.setDatum( 1, 1, 2022);
   betrag = +5000.11;
   liste1.pushBack( datum, betrag);

   cout << "\nDrei Elemente eingefuegt!"
           "\nInhalt der Liste:" << endl;
   cout << liste1 << endl;

   cout << "\nWeiter mit <Return>! "; cin.get();

   Liste liste2( liste1);
   cout << "Kopie der 1. Liste angelegt!\n"
           "Inhalt der Kopie:\n" << endl;
   cout << liste2 << endl;

   cout << "\nErstes Elemente der Liste entnehmen:\n";

   ListEl *ptrEl = liste1.front();
   if( ptrEl != NULL)
   {
      cout << "Geloescht wird:  " << *ptrEl << endl;
      liste1.popFront();
   }
   cout << "\nInhalt der Liste:\n";
   cout << liste1 << endl;

   liste1 = liste2;          // Kopie wieder zuweisen.

   cout << "Zuweisung der Kopie an die 1. Liste erfolgt!\n"
           "Inhalt nach der Zuweisung:\n" << endl;
   cout << liste1 << endl;

   return 0;
}
