// ------------------------------------------------ 
// iterat_t.cpp: Einen Vektor mit Konten ausgeben.
// ------------------------------------------------ 

#include <vector>
#include <iostream>
using namespace std;

#include "konto.h"

typedef vector<Konto> KontoVec; 

void display(const KontoVec& v);

int main()
{
    KontoVec kv;        // leerer Vector

    kv.push_back( Konto("Heidi", 12345UL, 1950.99));  // Einfgen
    kv.push_back( Konto("Hansi", 54321UL, 1150.99));
    kv.push_back( Konto("Irmi",  98765UL,  950.99));

    display(kv);                                      // Anzeigen

    return 0;
}

void display(const KontoVec& v)
{
    auto pos = v.begin();                 // Iterator
 // gleichbedeutend mit
 // KontoVec::const_iterator pos = v.begin(); 

   for(  ; pos < v.end(); pos++)
       pos->display();
   cout << endl;
}
