//---------------------------------------------------
// sortv_t.h : Zum Testen der Klasse SortVec.  
//---------------------------------------------------

#include "sortvec.h"
#include <iostream>
using namespace std;

typedef SortVec<int> SortVecInt;

void display(const SortVecInt& c);

int main()
{
   SortVecInt v, w;             // Default-Konstruktor

   v.insert(2);                 // Einfgen
   v.insert(7);
   v.insert(1);

   display(v);

   int key;
   cout << "Schluessel? " << endl;
   cin >> key; 
   
   int i = v.search(key);         // Suchen
   if( i > -1)
       cout << "Schluessel "  << key
            << " beim Index " << i << " gefunden!" << endl;
   else
       cout << "Schluessel "  << key << " nicht gefunden!" << endl; 
   
   cout << "\nJetzt in den zweiten Vektor einfuegen: " << endl;
   w.insert(3);                   // Einfgen
   w.insert(9);
   display(w);
   
   cout << "\nUnd die Vektoren mischen: " << endl;
   v.merge(w);                    // Mischen
   
   display(v);
   return 0;
}

void display(const SortVecInt& vec)
{
   for( int n : vec)
     cout << n << ' ';
   cout << endl;
}
