// ------------------------------------------------------
// suche.cpp
// Ein Filter, der alle Zeilen mit einem bestimmmten
// Muster ausgibt. Verwendet die Funktion strstr().
//
// Aufruf:    suche  muster [ < text.dat ]
//
// Ohne Angabe einer Datei wird von der Tastatur gelesen.
// In diesem Fall die Eingabe mit <Strg> + <Z> (Windows)
// bzw. <Strg> + <D> (Linux / Unix) beenden.
// ------------------------------------------------------
#include <iostream>
#include <cstring>      // Standardfunktionen fr C-Strings
using namespace std;

#define MAXL  200                // Maximale Zeilenlnge
char zeile[MAXL];                // Fr eine Zeile Text.

int main( int argc, char *argv[])
{
   if( argc != 2)
   {
     cerr << "Aufruf:  suche  muster [ < text.dat ]"
          << endl;
     return 1;
   }

   int zeilenNr = 0;
                     // Solange noch eine Zeile da ist:
   while( cin.getline( zeile, MAXL))
   {
     ++zeilenNr;
     if( strstr( zeile, argv[1]) != NULL)
     {                           // Falls Muster gefunden:
        cout.width(3);
        cout << zeilenNr << ": "         // Zeilennr. und
             << zeile << endl;           // Zeile ausgeben
     }
   }
   return 0;
}
