// Pizza_W.cpp 
// Demo fr blockweises Schreiben von Datenstzen.
// ---------------------------------------------------

#include <iostream>
#include <fstream>
using namespace std;

char header[] =
"    * * *  P I Z Z A  P R O N T O  * * *\n\n";

// Datensatz-Struktur:
struct Pizza
{  
    char name[32];
    float preis;
};

const int MAXANZ = 10;

Pizza pizzaKarte[MAXANZ] = 
{
   { "Margerita", 9.90F },    { "Regina", 15.90F },
   { "Pizza Fungi", 12.50F }, { "Calzone", 14.90F }
};
int anz = 4;

char pizzaDatei[256] = "pizza.dat";
 
int main()               // Datenstze schreiben. 
{
   cout << header  << endl;
 
   // Daten in die Datei schreiben:
   int exitCode = 0;
   ofstream outFile( pizzaDatei, ios::out|ios::binary );
   if( !outFile)
   {
      cerr << "Fehler beim ffnen der Datei!" << endl;
      exitCode = 1;
   }
   else
   {
      for( int i = 0; i < anz; ++i)
        if( !outFile.write( (char*)&pizzaKarte[i], sizeof(Pizza)) )
        {
           cerr << "Fehler beim Schreiben!" << endl;
           exitCode = 2;
        }
   }
   if( exitCode == 0)
     cout << "\nDaten in die Datei " << pizzaDatei
          << " geschrieben\n" << endl;
 
   return  exitCode;
}
