// showfile.cpp
// Liest eine Textdatei und gibt sie "seitenweise",  
// d.h. jeweils 20 Zeilen, am Bildschirm aus.
// Aufruf:  showfile  textdatei 
// ----------------------------------------------------

#include <iostream>
#include <fstream>
using namespace std;

int main( int argc, char *argv[])
{
   if( argc != 2 )
   {
       cerr << "Benutzung: showfile dateiname" << endl;
       return 1;
   }
   ifstream datei( argv[1]);    // Stream anlegen und  
                                // Datei zum Lesen ffnen.
   if( !datei )
   {
     cerr << "Fehler beim Oeffnen der Datei " << argv[1]
          << endl;
     return 2;
   }

   char zeile[80];
   int anzahl = 0;
   while( datei.getline( zeile, 80))  // Datei auf die
   {                                  // Standardausgabe 
      cout << zeile << endl;          // kopieren.
      if( ++anzahl == 20)
      {
        anzahl = 0;
        cout << "\n\t ---- Weiter mit <Return> ---- "
             << endl;
        cin.get();
      }
   }

   if( !datei.eof() )
   {
     cerr << "Fehler beim Lesen der Datei " << argv[1]
          << endl;
     return 3;
   }
   return 0;
}
