// DynArr.cpp
// Die Operatoren new[] und delete[] fr dynamische Arrays.
// --------------------------------------------------------

#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
   cout << "Einen dynamischen Array verwenden.\n" << endl;

   int size = 0, anz = 0, step = 10,
       i;
   float x, *pArr = NULL;

   cout << "Zur Berechnung Zahlen eingeben!\n"
           "Ende: q oder anderer Buchstabe"
        << endl;

   while( cin >> x)
   {
      if( anz >= size)           // Vektor zu klein?
      {                          // => vergrern.
          float *p = new float[size+step];
                                 // Zahlen kopieren
          for( i = 0; i < size; ++i)
              p[i] = pArr[i];
          delete [] pArr;        // Alten Vektor freigeben
          pArr = p;  size += step;
      }
      pArr[anz++] = x;
   }
   // Mit den Zahlen arbeiten:
   if( anz == 0)
     cout << "Keine gltige Eingabe!" << endl;
   else
   {
     float summe = 0.0;
     cout << "Ihre Eingabe: " << endl;
     for( i = 0; i < anz; i++)
     {
       cout << setw(10) << pArr[i];
       summe += pArr[i];
     }
     cout << "\nMittelwert: " << summe/anz << endl;
   }
   delete [] pArr;            // Speicher freigeben
   return 0;
}
