// --------------------------------------------------- 
//  NoCtrl.cpp
//  Filterprogramm das Steuerzeichen "ausblendet"
//  Aufrufbeispiel:  NoCtrl < datei
// --------------------------------------------------- 

#include <iostream>
using namespace std;

#define isCtrl(c) ( c >= 0 && c <= 31 && c != '\n' && c != '\t')

int main()
{
   char c, prec = 0;           // Zeichen und Vorgnger
   long nCtrl = 0, nChar = 0;  // Anzahl zusammenhngender 
                               // Steuerzeichen bzw. Zeichen
   while( cin.get(c) )
   { 
     if( isCtrl(c))            // Steuerzeichen
     {
         ++nCtrl;
         nChar = 0;
     }
     else                      // normales Zeichen
     {
        if( nCtrl > 0)
        {
           cout.put(' ');
           nCtrl = 0;
        }
        switch( ++nChar)
        {
           case 1:   break;
           case 2:   cout.put(prec);    // Vorgnger und
           default:  cout.put(c);       // akt. Zeichen
        }
        prec = c;
     }
   }
   return 0;
}
