// -------------------------------------------------------
// TimeTab.cpp 
// Ein Array mit Objekten der Klasse DayTime.
// -------------------------------------------------------

#include "DayTime.h"      // Definition der Klasse DayTime
#include <iostream>
using namespace std;

char header[] =
"\n\n      ***  Tabelle mit Tageszeiten  ***\n\n";

int main()
{
  DayTime timeTab[4] = { 18, DayTime(10,25), DayTime(14,55,30)};
  int i;

  timeTab[3].setTime( 8,40,50);    // Letztes Element.

  cout << header << endl;

  // Ausgabe
  for( i = 0; i < 4; ++i)
  {
     timeTab[i].print();
     cout << endl;
  }

  // Kleinste und grte Zeit ermitteln:
  int i_min = 0, i_max = 0;        // Indizes fr kleinstes
                                   // und grtes Element.
  for( i = 1; i < 4; ++i)
  {
     if( timeTab[i].isLess( timeTab[i_min]) )
         i_min = i;
     
     if( timeTab[i_max].isLess( timeTab[i]) )
         i_max = i;
  }

  cout << "\nKleinste Zeit: ";  timeTab[i_min].print();
  cout << "\nGroesste Zeit: ";  timeTab[i_max].print();

  return 0;
}
