// calc_err.cpp: Definition und Test der Funktion calc(),
//               die Exceptions auslst.
// --------------------------------------------------------
#include <iostream>
#include <string>
using namespace std;

double calc( int a, int b );

class Error
{
    // Infos ber Fehlerursache. Hier keine
};

int main()
{
    int x, y;
    double erg;
    bool flag = false;

    do
    {
       try                                 // try-Block
       {
         cout << "Zwei positive ganze Zahlen eingeben: ";
         if( !(cin >> x >> y))
             break;                   // Keine Zahlen  
         erg = calc( x, y);
         cout << x << "/" << y << " = " << erg << endl;
         flag = true;        // Dann Schleife verlassen.
       }
       catch( string& s)              // 1. catch-Block
       {
         cerr << s << endl;
       }
       catch( Error& )               // 2. catch-Block
       {
         cerr << "Division durch 0! \n" << endl;
       }
       catch(...)                    // 3. catch-Block
       {
         cerr << "Unerwartete Exception! \n";
         exit(1);
       }
    }while(!flag);

    // und weiter im Programm ...
    return 0; 
}

double calc( int a, int b )
{
   if ( b < 0 )
      throw (string)"Nenner ist negativ!";
 
   if( b == 0 )
   {
      Error errorObj;
      throw errorObj;
   }

   return ((double)a/b);
}
