// ---------------------------------------
// konto.h: Definition der Klasse Konto
// ---------------------------------------
#ifndef KONTO_H
#define KONTO_H

#include <iomanip>
#include <string> 
using namespace std;

class Konto
{
    private:
      string name;
      unsigned long nr;
      double stand;

    public:
      Konto(const string s = "X", unsigned long n = 1111111L,  double st = 0.0)
      : name(s), nr(n), stand(st)
      { } 

      long getNr() const { return nr; }
      void setNr(unsigned long n){ nr = n; }
      // usw.
      
      void display() const
      { 
          cout << fixed << setprecision(2)
               << "----------------------------------\n"
               << "Kontoinhaber:       " << name  << endl
               << "Kontonummer:        " << nr    << endl
               << "Kontostand:         " << stand << endl
               << "----------------------------------\n"
               << endl;
      }
};

#endif
